//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~External-Variables:
extern double Risk_Percentage=2;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Global-Variables:
int     i,x,Sakis_Magic=1,Order_Max=2,iHour=3600,
        Ma_Cross_Time,Ma_Cross_Dir, Macd_Cross_Time, Macd_Cross_Dir;
double  Lots, Ans, Point2Pip, Slippage, Stop_Level, Broker_Min,Broker_Max, 
        Sl_Price, Median_Price;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Init-Function:
int init(){
//~~~~~~~~~~
    Slippage=     MarketInfo(Symbol(),MODE_SPREAD);
    Stop_Level=   MarketInfo(Symbol(),MODE_STOPLEVEL);
    Broker_Min=   MarketInfo(Symbol(),MODE_MINLOT);
    Broker_Max=   MarketInfo(Symbol(),MODE_MAXLOT);
    //~~~~~~~~~~Point2Pip:
    Point2Pip=Point;
    if(Digits==3){Point2Pip=0.01;}
    if(Digits==5){Point2Pip=0.0001;}
//~~~~~~~~~~
return(0);}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Start-Function:
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int start(){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~My-Comments:
Comment(
  "Account_Equity=",AccountEquity(),"\n"
);
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Indicator Values;
double Ma_50=   iMA("EURUSD",PERIOD_H1,50,0,MODE_SMA,PRICE_CLOSE,0);
double Ma_100=  iMA("EURUSD",PERIOD_H1,100,0,MODE_SMA,PRICE_CLOSE,0);
double Macd_0=  iMACD("EURUSD",PERIOD_H1,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
double Macd_1=  iMACD("EURUSD",PERIOD_H1,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Money-Management & OrderClose:
if(OrdersTotal()> 1){
    if(AccountEquity()<AccountBalance()-
        AccountBalance()*(Risk_Percentage/100)){Order_Manage(0,'t');}
    //~~~~~~~~~~
    for(x=1;x>=-1;x--){
        if(AccountEquity()>AccountBalance()+
            AccountBalance()*(Risk_Percentage/100)){Order_Manage(Sakis_Magic*x,'l');
            if(OrdersTotal()==1){
                if(Order_Manage(Sakis_Magic*x,'s')>0){
                    Sl_Price=OrderOpenPrice();}}}
    x--;
}}

//~~~~~~~~~~Close Last Order@ BreakEven:
for(x=1;x>=-1;x--){
    if(Order_Manage(Sakis_Magic*x,'s')>0){
        if(OrderType()==OP_BUY && Bid<=Sl_Price){Order_Manage(0,'t');}
        if(OrderType()==OP_SELL && Ask>=Sl_Price){Order_Manage(0,'t');}
}x--;}

//~~~~~~~~~~Moving Average Cross Values:
for(x=1;x>=-1;x--){
    if(Order_Manage(Sakis_Magic*x,'s')>0){
    if(Sl_Price==OrderOpenPrice()){
        if((Sign(Open[1]-Ma_50)!=Sign(x) || Sign(Open[1]-Ma_100)!=Sign(x))
        &&(Sign(Close[1]-Ma_50)==Sign(x) && Sign(Close[1]-Ma_100)==Sign(x))){
            Order_Manage(0,'t');
    }}}x--;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Variable-PreSets:
Lots=0.1; if(Broker_Min>0.1){Lots=Broker_Min;} Median_Price=(Bid+Ask)/2;
if(OrdersTotal()<1){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Moving Average Cross Values:
for(x=1;x>=-1;x--){
    if(iVolume("EURUSD",PERIOD_H1,0)==1){
        if((Sign(Open[1]-Ma_50)!=Sign(x) || Sign(Open[1]-Ma_100)!=Sign(x))
        &&(Sign(Close[1]-Ma_50)==Sign(x) && Sign(Close[1]-Ma_100)==Sign(x))){
            Ma_Cross_Dir=x; Ma_Cross_Time=TimeCurrent();
    }}x--;
}
//~~~~~~~~~~Macd Cross ZeroLine Values:
for(x=1;x>=-1;x--){
    if(Sign(Macd_1)!=x && Sign(Macd_0)==x){
        Macd_Cross_Dir=x; Macd_Cross_Time=TimeCurrent();
    }x--;
}}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Sakis-Order-Origin:
for(x=1;x>=-1;x--){
    if(Ma_Cross_Dir==x && Macd_Cross_Dir==x 
    && MathAbs(Ma_Cross_Time-Macd_Cross_Time)< iHour*5){
        if(x>0){
            Sl_Price=iLow("EURUSD",PERIOD_H1,
                     iLowest("EURUSD",PERIOD_H1,MODE_LOW,  5,0));}
        if(x<0){
            Sl_Price=iHigh("EURUSD",PERIOD_H1,
                     iHighest("EURUSD",PERIOD_H1,MODE_HIGH,5,0));}
        if(Lots==0.1 || Broker_Min){Lots=Lot_Size();}
        if(Send_Mkt(Sakis_Magic*x)>0){
                if(OrdersTotal()==2){
                    Ma_Cross_Dir=0;Macd_Cross_Dir=0;Ma_Cross_Time=0;Macd_Cross_Time=0;
        }}
    }x--;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
            Alert("**OrderSend**"+x);ObjectsDeleteAll();
            ObjectCreate("**OrderSend**",OBJ_VLINE,0,Time[0],Open[0]);
*/
return(0);}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~User_Defined-Functions:
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Sign-Function:
int Sign(double Value){
//~~~~~~~~~~
    if(Value<0){return(-1);}else{return(1);}
//~~~~~~~~~~
return(0);}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Lot_Size-Function
double Lot_Size(){Ans=0;
//~~~~~~~~~~
Sl_Price=NormalizeDouble(Sl_Price,4);
Median_Price=NormalizeDouble(Median_Price,4);
//~~~~~~~~~~
    Ans=(AccountEquity()*(Risk_Percentage/100))/
        (MathAbs(Sl_Price-Median_Price)*100000) /Order_Max;
    if(Ans<Broker_Min){Ans=Broker_Min;}
    if(Ans>Broker_Max){Ans=Broker_Max;}
//~~~~~~~~~~
return(Ans);}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Send_Mkt-Function
int Send_Mkt(int Magic){Ans=0;
//~~~~~~~~~~
    string Str_Magic;
    //~~~~~~~~~~
    if(Magic>0){
        if(Order_Manage(Magic,'m')>=Order_Max){Magic=0;}}
    if(Magic>0){
        Str_Magic="Buy_Magic= "+DoubleToStr(Magic,0);
        OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,
        0,0,Str_Magic,Magic,0,Blue);
    }
    //~~~~~~~~~~
    if(Magic<0){
        if(Order_Manage(Magic,'m')>=Order_Max){Magic=0;}}
    if(Magic<0){
        Str_Magic="Sell_Magic= "+DoubleToStr(Magic,0);
        OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,
        0,0,Str_Magic,Magic,0,Red);
    }
//~~~~~~~~~~
return(Ans);}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Order_Manage-Function
double Order_Manage(int Magic,int Switch){Ans=0;
    for(i=OrdersTotal()-1;i>=0;i--){
        if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true
            && OrderSymbol()==Symbol()){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            switch(Switch){
                case 'm':   if(OrderMagicNumber()==Magic && Switch=='m'){Ans++;break;}
                case 'a':   if(OrderMagicNumber()==Magic && Switch=='a'){
                                OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),
                                Slippage,White);break;}
                case 't':   if(Switch=='t'){
                                OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),
                                Slippage,White);break;}
                case 'l':   if(OrderMagicNumber()==Magic && Switch=='l'){
                                Ans=OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),
                                Slippage,White);return(Ans);}
                case 's':   if(OrderMagicNumber()==Magic && Switch=='s'){
                                Ans=OrderTicket();return(Ans);}
            }
    }}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
return(Ans);}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~